<template>
  <header :class="{ loading }">
    <modal v-if="photoModal" @close="photoModal = false">
      <div class="photo-modal-container">
        <div ref="modalPhotoList" class="modal-photo-list">
          <div class="modal-photo-item" v-for="p in restaurant.images">
            <img class="modal-photo img-fluid" :src="p" />
          </div>
        </div>
      </div>
    </modal>
    <div class="restaurant-photo-list flex" :class="themeClasses">
      <div v-if="loading" class="restaurant-photo-item">
        <div class="restaurant-photo lp lp--large"></div>
      </div>
      <div
        v-if="!loading"
        class="restaurant-photo-item"
        :key="p"
        v-for="(p, i) in bannerImages"
      >
        <div
          @click="showModalPhoto(i)"
          class="restaurant-photo"
          :style="{ 'background-image': `url('${p}')` }"
        ></div>
      </div>
    </div>
    <div
      class="restaurant-header-content-container container m-container-no-gutter"
    >
      <div class="row">
        <div class="restaurant-side-column col-12 col-md-3">
          <div ref="headerContainer"></div>
          <div class="restaurant-header-content" :class="{ fixed }">
            <div :class="{ container: fixed }">
              <div :class="{ row: fixed }">
                <div
                  :class="{ 'restaurant-side-column col-12 col-md-3': fixed }"
                >
                  <div class="flex d-md-block">
                    <div>
                      <div
                        class="company-logo lp"
                        :style="{
                          'background-color': company.webBannerBackgroundColor
                        }"
                      >
                        <div
                          class="relative-full bg-center-contain-nr"
                          :style="{
                            'background-image': `url('${restaurant.logoSM}')`
                          }"
                        ></div>
                      </div>
                    </div>
                    <div>
                      <div class="company-info">
                        <h1 class="restaurant-name title lp">
                          {{ company.name }}
                        </h1>
                        <div class="caption">
                          <div class="restaurant-address lp">
                            {{ buildingAddress }}
                          </div>
                          <div class="restaurant-type lp">
                            {{
                              $t(`restaurantTypes.${restaurant.restaurantType}`)
                            }}
                          </div>
                        </div>
                      </div>

                      <div
                        v-if="
                          sections.length && !isPreorderTab && !isDeliveryTab
                        "
                        class="restaurant-section-nav d-none d-md-block"
                        :class="themeClasses"
                      >
                        <ul class="reset-list">
                          <li
                            v-for="section in sections"
                            :key="section.name"
                            class="restaurant-section-item"
                          >
                            <a
                              @click.prevent="
                                $emit('goToSection', section.name)
                              "
                              :class="{
                                'restaurant-section-link--active':
                                  section.active
                              }"
                              class="restaurant-section-link"
                              >{{ $t(`restaurant.${section.name}`) }}</a
                            >
                          </li>
                        </ul>
                      </div>

                      <slot
                        v-if="isPreorderTab || isDeliveryTab"
                        name="preorderMenu"
                      />
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </header>
</template>
<script>
import Modal from "@/components/Modal";
import { mapState, mapGetters } from "vuex";

import "flickity-imagesloaded";
import Flickity from "flickity";

const oneBuildingGroup = {
  taichung: true,
  TaipeiStation: true,
  KaohsiungSanduo: true,
  TainanZhongshan: true,
  ChiayiChuiyang: true,
  TaoyuanDayou: true,
  TaoyuanStation: true
};

export default {
  components: {
    Modal
  },
  props: {
    restaurant: {
      type: Object,
      default: () => {
        return {
          images: [],
          company: {
            logo: ""
          }
        };
      }
    },
    sections: {
      type: Array,
      required: false,
      default: () => {
        return [];
      }
    },
    loading: {
      type: Boolean
    },
    groupId: {
      type: String
    }
  },
  computed: {
    ...mapState(["isMobile"]),
    ...mapGetters("theme", ["themeClasses"]),
    company() {
      return this.restaurant.company;
    },
    bannerImages() {
      const images = this.restaurant.images.slice(0, 3);
      const operation = {
        true: {
          1: "?fit=max&w=1050",
          2: "?fit=max&w=525",
          3: "?fit=max&w=350"
        },
        false: {
          1: "?fit=max&w=2100",
          2: "?fit=max&w=1050",
          3: "?fit=max&w=700"
        }
      }[this.isMobile][images.length];
      return images.map(i => `${i}${operation}`);
    },
    buildingAddress() {
      if (oneBuildingGroup[this.realGroupId]) {
        return this.restaurant.buildingAddressWithoutBuilding;
      }
      return this.restaurant.buildingAddress;
    },
    realGroupId() {
      return this.groupId && this.groupId.split("-")[1];
    },
    isPreorderTab() {
      return this.$route.name === "RestaurantPreorder";
    },
    isDeliveryTab() {
      return this.$route.name === "RestaurantDelivery";
    }
  },
  data() {
    return {
      fixed: false,
      photoModal: false,
      photoModalIndex: 0
    };
  },
  watch: {
    photoModal(v) {
      if (v) {
        setTimeout(() => {
          this.flickity = new Flickity(this.$refs.modalPhotoList, {
            imagesLoaded: true,
            pageDots: false,
            prevNextButtons: true,
            setGallerySize: false,
            adaptiveHeight: true,
            arrowShape: {
              x0: 15,
              x1: 60,
              y1: 50,
              x2: 65,
              y2: 45,
              x3: 25
            }
          });
          this.flickity.select(this.photoModalIndex);
        });
      } else {
        this.flickity.destroy();
      }
    }
  },
  methods: {
    updateFixedFilter() {
      if (this.$refs.headerContainer) {
        this.fixed =
          !this.isMobile &&
          this.$refs.headerContainer.getBoundingClientRect().top <= 0;
      }
    },
    initFixedHeader() {
      setTimeout(() => {
        window.addEventListener("scroll", this.updateFixedFilter);
      }, 0);
    },
    showModalPhoto(i) {
      this.photoModal = true;
      this.photoModalIndex = i;
      window.gtag("event", "Restaurant cover photo - Open", {
        event_label: JSON.stringify({
          ...this.restaurant.dataForMixpanel
        })
      });
    }
  },
  destroyed() {
    window.removeEventListener("scroll", this.updateFixedFilter);
  },
  mounted() {
    this.initFixedHeader();
  }
};
</script>
<style lang="scss" scoped>
.restaurant-header-content {
  .restaurant-side-column {
    padding: 0 30px 0 0;
  }
  @include media-breakpoint-up(md) {
    padding-top: 20px;
    position: absolute;
    width: 100%;
    left: 0;
    padding-right: 30px;

    &.fixed {
      position: fixed;
      top: 0;
      padding-right: 0;
    }
  }
}

.restaurant-photo-item {
  flex: 1 1 0;
}

.restaurant-photo {
  height: 108px;
  background-repeat: no-repeat;
  background-size: cover;
  background-position: center;
  background-color: $color-sky-grey;
  @include media-breakpoint-up(md) {
    height: 280px;
  }
}

.restaurant-header-content-container {
  @include media-breakpoint-up(md) {
    margin-top: -60px;
    // magic, dont ask
    margin-bottom: 60px;
  }
}

.company-logo {
  width: 80px;
  height: 80px;
  padding: 8px;
  border: 5px solid $color-white;
  background-color: $color-genesis-white;
  margin: -$grid-gutter-width/2 $grid-gutter-width 0 $grid-gutter-width;
  display: flex;
  align-items: center;
  justify-content: center;
  @include media-breakpoint-up(md) {
    margin: 0;
    width: 140px;
    height: 140px;
  }
}

.company-info {
  padding: $grid-gutter-width/2 0 0 0;
  @include media-breakpoint-up(md) {
    margin-bottom: 40px;
  }
}

.restaurant-name {
  @include media-breakpoint-up(md) {
    font-size: 28px;
    margin: 20px 0 12px 0;
  }
}

.restaurant-address,
.restaurant-type {
  line-height: 1;
  margin-bottom: 0.5em;
  @include media-breakpoint-up(md) {
    font-size: 16px;
  }
}

.restaurant-section-nav {
  padding: 35px 0;
  background-color: $color-white;

  &.theme-vip-member {
    background-color: $color-gold-100;
    @include media-breakpoint-up(md) {
      background-color: $color-white;
    }
  }
}

.restaurant-section-item {
  & + & {
    margin-top: 30px;
  }
}

.restaurant-section-link {
  display: block;
  border-left: 4px solid rgba($color-skm-red, 0);
  padding: 0 5px 0 10px;
  line-height: 1.2;

  font-size: 18px;
  transition: all 0.3s;
  cursor: pointer;

  @include media-breakpoint-up(lg) {
    padding: 5px 15px 5px 30px;

    &:lang(en) {
      padding: 5px 15px 5px 15px;
    }
  }

  &--active {
    border-color: rgba($color-skm-red, 2);
    font-weight: 500;
  }
}

.photo-modal-container {
  position: relative;
  max-width: 1080px;

  height: 100%;
  margin: auto;
  display: flex;
  justify-content: center;
  align-items: center;
  @include media-breakpoint-up(md) {
    width: 85%;
  }
}

.modal-photo-list {
  width: 100%;
  height: 100%;
}

.modal-photo-item {
  width: 100%;
  height: 100%;
  display: flex;
  justify-content: center;
  align-items: center;
}

.loading {
  .restaurant-name,
  .restaurant-type {
    width: 68px;
  }
  .restaurant-address {
    width: 185px;
  }
}
</style>
<style lang="scss">
.photo-modal-container {
  .flickity-prev-next-button {
    background-color: transparent;
    transform: scale(2) translateY(-25%);
    transform-origin: center;
    display: none;
    &.previous {
      left: -55px;
    }
    &.next {
      right: -55px;
    }
    .arrow {
      fill: white;
    }
  }
  @include media-breakpoint-up(md) {
    .flickity-prev-next-button {
      display: block;
    }
  }
}

.restaurant-photo-list.theme-vip-member {
  position: relative;

  &:after {
    content: "";
    position: absolute;
    left: 0;
    bottom: 0;
    background-image: url("/static/images/ic-gold-frame.png");
    background-size: 200px 6px;
    height: 6px;
    width: 100%;
  }
}
</style>
